package app.main;

import java.util.ArrayList;

import ryulib.OnNotifyEventListener;

public class PieceList {
	
	private ArrayList<Piece> _List = new ArrayList<Piece>();
	
	public void clear() {
		_List.clear();
	}
	
	private OnNotifyEventListener _OnPieceMoved = new OnNotifyEventListener() {
		@Override
		public void onNotify(Object sender) {
			checkGameEnd();
		}
	};
	
	public void add(Piece piece) {
		_List.add(piece);
		piece.setOnMoved(_OnPieceMoved);
	}
	
	private void checkGameEnd() {
		Block[][] blocks = new Block[Global.boardSize][Global.boardSize];
		
		for (int y=0; y<Global.boardSize; y++) {
			for (int x=0; x<Global.boardSize; x++) {
				blocks[x][y] = null;
			}
		}
		
		for (Piece piece : _List) {
			for (Block block : piece._Blocks) {
				int x = piece.getX() + block.getX();
				int y = piece.getY() + block.getY();
				boolean isInRange =
					(x >= 0) && (x < Global.boardSize) &&
					(y >= 0) && (y < Global.boardSize);
					
				if (isInRange) blocks[x][y] = block;
			}
		}
		
		for (int y=0; y<Global.boardSize; y++) {
			for (int x=0; x<Global.boardSize; x++) {
				if (blocks[x][y] == null) return; 
			}
		}
		
		if (_OnGameEnd != null) _OnGameEnd.onNotify(this);
	}
	
	private OnNotifyEventListener _OnGameEnd = null;
	
	public void setOnGameEnd(OnNotifyEventListener _OnGameEnd) {
		this._OnGameEnd = _OnGameEnd;
	}

	public OnNotifyEventListener getOnGameEnd() {
		return _OnGameEnd;
	}

}
